#ifndef GESTORRANKING_H
#define GESTORRANKING_H

#include <iostream>
#include <list>
#include <fstream>

using namespace std;

//una estructura que representa una puntuación
struct Puntuacion
{
	string nombre;
	int puntos;
};

//se encarga de obtener el ranking del fichero y de insertar una nueva entrada
class GestorRanking
{
	public:
		//obtiene la lista con las 10 mejores puntuaciones
		static void getRanking(list<Puntuacion> &ranking);
		//añade una nueva puntuación
        static void setRanking(list<Puntuacion> &ranking, Puntuacion &puntuacion);	

	private:
		//Constructor privado
		GestorRanking();
		//lee el fichero y lo pone en la lista
		static void leerFichero(list<Puntuacion> &ranking, ifstream *fe);
		//escribe en el fichero el contenido de la lista
		static void escribirFichero(list<Puntuacion> &ranking, ofstream *fs);
		//función auxiliar para la ordenación de la lista
		static bool compararPuntos(Puntuacion p1, Puntuacion p2);
};

#endif
