#include "Graficos.h"
#include <iostream>
#include <sstream>

#include <ctime>
#include <cstdlib>
#include <unistd.h>

using namespace std;
using namespace STDP;

StdPijo* Graficos::stdp = NULL;

int Graficos::menu[25][80];	
int Graficos::cntMecha=0;

int Graficos::manPosX=0;
int Graficos::manPosY=0;
int Graficos::minesAround=0;
int Graficos::option=1;
int Graficos::cntMinas=0;

Color* Graficos::colores = new Color[8];

Graficos::Graficos()
{
	
}

string int2string(int n)
{
	stringstream flujo;
	flujo << n;
	return (flujo.str());
}

void Graficos::init()
{
	// Obtenemos referencia de acceso a StdPijo
    
	stdp = &StdPijo::p();

    // Inicializamos la pantalla
    stdp->init();

    // Borramos la pantalla
    stdp->clearScreen();

    // 0 Segundos de retardo de espera desde que se recibe un
    // caracter de escape por la entrada estándar. Esto sirve para
    // que no tengamos que esperar cuando pulsamos la tecla escape
    // a que verifique que no es un código de escape.
    stdp->setGlobalEscapeDelay(0);

	for (int i=0; i< 24; i++)
	{
		for (int j=0; j< 80; j++)
		{
			menu[i][j] = ' ';
		}
	}
	for (int i=0; i< 24; i+=4)
	{
		for (int j=0; j< 80; j+=4)
		{
			menu[i][j] = 124;
		}
	}
	for (int i=2; i< 24; i+=4)
	{
		for (int j=2; j< 80; j+=4)
		{
			menu[i][j] = 124;
		}
	}

	colores[0]=	CBLACK;
    colores[1]=CRED;      
    colores[2]=CGREEN;     
    colores[3]=CYELLOW;    
    colores[4]=CBLUE;      
    colores[5]=CMAGENTA;   
    colores[6]=CCYAN;      
    colores[7]=CWHITE;     
}

void Graficos::updateMenu()
{
	int i,j;

	//dibujamos fondo
	stdp->setColor(ANORMAL, CBLUE, CBLUE);
	for (i=0; i< 24; i++)
	{
		for (j=0; j< 80; j++)
		{
			stdp->setCursor(j, i);
			
    		stdp->writeChar(menu[i][j]);  
		}
	}
	//dibujamos MANY
	dibujarMANY();

	//dibujamos MINES
	dibujarMINES();

	//opciones
	stdp->setColor(ANORMAL, CRED, CBLUE);
	stdp->setCursor(38, 18);
	stdp->writeStr("NEW GAME");

	stdp->setCursor(38, 20);
	stdp->writeStr("RANKING");

	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	if (option==1)
		stdp->setCursor(33, 18);
	else
		stdp->setCursor(33, 20);
	stdp->writeStr(">");

	//salir es escape
	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(69, 0);
	stdp->writeStr("ESC - EXIT");

	//dibujamos space para fin
	stdp->setCursor(0,23);
	stdp->writeStr("W,S,A,D - MOVE");

	stdp->refreshScr();
}

void Graficos::setManPos(int x, int y)
{
	manPosX = x * 2 + 1;
	manPosY = y + 1;
}

void Graficos::setMinesAround(int mines)
{
	minesAround=mines;
}

void Graficos::updateGame(int tablero[][22], int level, int tiempo, int score, bool drawMines)
{
	int i,j;

	stdp->setColor(ANORMAL, CBLACK, CGREEN);

	//dibujar tablero
	//separadores
	for (i=2; i<25; i++)
	{
		for (j=0; j<80; j++)
		{
			stdp->setCursor(j, i);
			
			if (j%2==0)
				stdp->writeChar('|');
		}		
	}
	//dibujar contenido del tablero
	for (i=0; i<39; i++)
	{
		for (j=0; j<22; j++)
		{
			stdp->setCursor(i*2 + 1, j+2);

			if (tablero[i][j]==0)
			{
				stdp->setColor(ANORMAL, CBLACK, CGREEN);
				stdp->writeChar(' ');
			}
			if (tablero[i][j]==1)
			{
				stdp->setColor(ANORMAL, CBLACK, CBLUE);
				stdp->writeChar(' ');
			}
			if (tablero[i][j]==2)
			{
				if (drawMines && cntMinas<18)
				{
					stdp->setColor(ANORMAL, CBLACK, CGREEN);
					stdp->writeChar('*');					
				}
				else
				{
					stdp->setColor(ANORMAL, CBLACK, CGREEN);
					stdp->writeChar(' ');
				}
			}
		}
	}

	if (cntMinas>25)
	{
		cntMinas = 0;
	}
	else
	{
		cntMinas++;
	}

	//dibujar personaje
	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(manPosX,manPosY+1);
	stdp->writeChar('O');
	
	//dibujar llegada
	stdp->setColor(ANORMAL, CWHITE, CWHITE);
	for (i=0; i<79; i++)
	{
		stdp->setCursor(i,1);
		stdp->writeChar(' ');
	}
	stdp->setColor(ANORMAL, CBLACK, CWHITE);
	stdp->setCursor(38,1);
	stdp->writeStr("GOAL");

	//dibujar borde derecho
	stdp->setColor(ANORMAL, CBLACK, CBLACK);
	for (i=0; i<24; i++)
	{
		stdp->setCursor(79,i);
		stdp->writeChar(' ');
	}
	
	//dibujar HUD
	stdp->setColor(ANORMAL, CBLACK, CCYAN);
	stdp->setCursor(0,0);
	stdp->writeStr("Mines around you: ");
	if (minesAround==0)
		stdp->setColor(ABLINK, CBLACK, CGREEN);
	else if (minesAround==1)
		stdp->setColor(ABLINK, CBLACK, CYELLOW);
	else
		stdp->setColor(ABLINK, CBLACK, CRED);
	
	stdp->writeChar(minesAround + 48);

	//mostrar nivel
	stdp->setColor(ANORMAL, CBLACK, CCYAN);
	string cadenaAux = "  Level: ";
	cadenaAux += int2string(level);
	stdp->writeStr(cadenaAux.c_str());

	//mostrar tiempo total
	stdp->setColor(ANORMAL, CBLACK, CCYAN);
	cadenaAux = "  Seconds: ";
	cadenaAux += int2string(tiempo);
	stdp->writeStr(cadenaAux.c_str());

	//mostrar puntos
	stdp->setColor(ANORMAL, CBLACK, CCYAN);
	cadenaAux = "  Score: ";
	cadenaAux += int2string(score);
	stdp->writeStr(cadenaAux.c_str());
	stdp->writeStr("   ");

	//ponemos que ha muerto
	if (drawMines)
	{
		if (drawMines && cntMinas<18)
		{
			stdp->setCursor(38,1);
			stdp->setColor(ANORMAL, CRED, CWHITE);
			stdp->writeStr("BOOM!");
		}
		else
		{
			stdp->setCursor(38,1);
			stdp->setColor(ANORMAL, CRED, CWHITE);
			stdp->writeStr("    ");
		}
	}

	//salir es escape
	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(68, 0);
	stdp->writeStr("ESC - RETURN");

	stdp->refreshScr();
}

void Graficos::updateRanking(list<Puntuacion> ranking)
{
	int i,j;

	//dibujamos fondo
	stdp->setColor(ANORMAL, CBLUE, CBLUE);
	for (i=0; i< 24; i++)
	{
		for (j=0; j< 80; j++)
		{
			stdp->setCursor(j, i);
			
    		stdp->writeChar(' ');  
		}
	}

	//dibujamos la palabra ranking
	stdp->setColor(AUNDERLINE, CBLACK, CBLUE);
	stdp->setCursor(36,2);
	stdp->writeStr("Ranking");

	//dibujamos las posiciones del ranking
	list<Puntuacion>::iterator it = ranking.begin();
	i=0;
	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	while( it != ranking.end() )
	{
	  	stdp->setCursor(32,6+i);
		stdp->writeStr((*it).nombre.c_str());
		stdp->writeStr("  	  ");
		stdp->writeStr(int2string((*it).puntos).c_str());
		*it++;
		i++;
	}

	//salir es escape
	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(68, 0);
	stdp->writeStr("ESC - RETURN");

	stdp->refreshScr();
}

void Graficos::updateName(string name, int pos)
{
	int i,j;

	//dibujamos fondo
	stdp->setColor(ANORMAL, CBLUE, CBLUE);
	for (i=0; i< 24; i++)
	{
		for (j=0; j< 80; j++)
		{
			stdp->setCursor(j, i);
			
    		stdp->writeChar(' ');  
		}
	}

	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(40, 12);
	stdp->writeStr(name.c_str());

	stdp->setCursor(40 + pos, 13);
	stdp->writeChar('^');

	//dibujamos space para fin
	stdp->setCursor(68,23);
	stdp->writeStr("SPACE - END");

	//dibujamos space para fin
	stdp->setCursor(0,23);
	stdp->writeStr("W,S,A,D - MOVE");

	stdp->refreshScr();
}

void Graficos::updateCambio(int level, int cntFin)
{
	int i,j;

	//dibujamos fondo
	
	for (i=0; i< 24; i++)
	{
		for (j=0; j< 80; j++)
		{
			stdp->setColor(ANORMAL, CBLUE, CBLUE);
			stdp->setCursor(j, i);
	
			stdp->writeChar(' ');  
		}
	}

	stdp->setColor(ANORMAL, CBLACK, CBLUE);
	stdp->setCursor(38, 12);
	string cadLevel = "Level ";
	cadLevel += int2string(level);
	stdp->writeStr(cadLevel.c_str());

	//dibujamos space para fin
	stdp->setCursor(0,23);
	stdp->writeStr("W,S,A,D - MOVE");

	stdp->refreshScr();
}

void Graficos::end()
{
	// Restauramos el estado original del terminal
    stdp->end();
}

void Graficos::dibujarMANY()
{
	//M
	stdp->setColor(ANORMAL, CRED, CRED);
	stdp->setCursor(30,2);
	stdp->writeChar(' '); 
	stdp->setCursor(30,3);
	stdp->writeChar(' ');
	stdp->setCursor(30,4);
	stdp->writeChar(' ');
	stdp->setCursor(30,5);
	stdp->writeChar(' ');
	stdp->setCursor(30,6);
	stdp->writeChar(' ');
	stdp->setCursor(31,2);
	stdp->writeChar(' ');
	stdp->setCursor(32,3);
	stdp->writeChar(' ');
	stdp->setCursor(33,2);
	stdp->writeChar(' ');
	stdp->setCursor(34,2);
	stdp->writeChar(' ');
	stdp->setCursor(34,3);
	stdp->writeChar(' ');
	stdp->setCursor(34,4);
	stdp->writeChar(' ');
	stdp->setCursor(34,5);
	stdp->writeChar(' ');
	stdp->setCursor(34,6);
	stdp->writeChar(' ');

	//A
	stdp->setCursor(37,3);
	stdp->writeChar(' ');
	stdp->setCursor(37,4);
	stdp->writeChar(' ');
	stdp->setCursor(37,5);
	stdp->writeChar(' ');
	stdp->setCursor(37,6);
	stdp->writeChar(' ');
	stdp->setCursor(38,2);
	stdp->writeChar(' ');
	stdp->setCursor(38,4);
	stdp->writeChar(' ');
	stdp->setCursor(39,3);
	stdp->writeChar(' ');
	stdp->setCursor(39,4);
	stdp->writeChar(' ');
	stdp->setCursor(39,5);
	stdp->writeChar(' ');
	stdp->setCursor(39,6);
	stdp->writeChar(' ');

	//N
	stdp->setCursor(42,2);
	stdp->writeChar(' ');
	stdp->setCursor(42,3);
	stdp->writeChar(' ');
	stdp->setCursor(42,4);
	stdp->writeChar(' ');
	stdp->setCursor(42,5);
	stdp->writeChar(' ');
	stdp->setCursor(42,6);
	stdp->writeChar(' ');
	stdp->setCursor(43,3);
	stdp->writeChar(' ');
	stdp->setCursor(44,4);
	stdp->writeChar(' ');
	stdp->setCursor(45,5);
	stdp->writeChar(' ');
	stdp->setCursor(46,6);
	stdp->writeChar(' ');
	stdp->setCursor(46,5);
	stdp->writeChar(' ');
	stdp->setCursor(46,4);
	stdp->writeChar(' ');
	stdp->setCursor(46,3);
	stdp->writeChar(' ');
	stdp->setCursor(46,2);
	stdp->writeChar(' ');

	//Y
	stdp->setCursor(49,2);
	stdp->writeChar(' ');
	stdp->setCursor(50,3);
	stdp->writeChar(' ');
	stdp->setCursor(51,4);
	stdp->writeChar(' ');
	stdp->setCursor(52,3);
	stdp->writeChar(' ');
	stdp->setCursor(53,2);
	stdp->writeChar(' ');
	stdp->setCursor(50,5);
	stdp->writeChar(' ');
	stdp->setCursor(49,6);
	stdp->writeChar(' ');
}

void Graficos::dibujarMINES()
{
	//M
	stdp->setColor(ANORMAL, CRED, CRED);
	stdp->setCursor(25,10);
	stdp->writeChar(' '); 
	stdp->setCursor(25,11);
	stdp->writeChar(' ');
	stdp->setCursor(25,12);
	stdp->writeChar(' ');
	stdp->setCursor(25,13);
	stdp->writeChar(' ');
	stdp->setCursor(25,14);
	stdp->writeChar(' ');
	stdp->setCursor(26,10);
	stdp->writeChar(' ');
	stdp->setCursor(27,11);
	stdp->writeChar(' ');
	stdp->setCursor(28,10);
	stdp->writeChar(' ');
	stdp->setCursor(29,10);
	stdp->writeChar(' ');
	stdp->setCursor(29,11);
	stdp->writeChar(' ');
	stdp->setCursor(29,12);
	stdp->writeChar(' ');
	stdp->setCursor(29,13);
	stdp->writeChar(' ');
	stdp->setCursor(29,14);
	stdp->writeChar(' ');

	//I
	stdp->setCursor(32,9);
	stdp->writeChar(' ');
	stdp->setCursor(32,11);
	stdp->writeChar(' ');
	stdp->setCursor(32,12);
	stdp->writeChar(' ');
	stdp->setCursor(32,13);
	stdp->writeChar(' ');
	stdp->setCursor(32,14);
	stdp->writeChar(' ');

	//N
	stdp->setCursor(35,10);
	stdp->writeChar(' ');
	stdp->setCursor(35,11);
	stdp->writeChar(' ');
	stdp->setCursor(35,12);
	stdp->writeChar(' ');
	stdp->setCursor(35,13);
	stdp->writeChar(' ');
	stdp->setCursor(35,14);
	stdp->writeChar(' ');
	stdp->setCursor(36,11);
	stdp->writeChar(' ');
	stdp->setCursor(37,12);
	stdp->writeChar(' ');
	stdp->setCursor(38,13);
	stdp->writeChar(' ');
	stdp->setCursor(39,14);
	stdp->writeChar(' ');
	stdp->setCursor(39,13);
	stdp->writeChar(' ');
	stdp->setCursor(39,12);
	stdp->writeChar(' ');
	stdp->setCursor(39,11);
	stdp->writeChar(' ');
	stdp->setCursor(39,10);
	stdp->writeChar(' ');

	//E
	stdp->setCursor(42,10);
	stdp->writeChar(' ');
	stdp->setCursor(43,10);
	stdp->writeChar(' ');
	stdp->setCursor(44,10);
	stdp->writeChar(' ');
	stdp->setCursor(45,10);
	stdp->writeChar(' ');
	stdp->setCursor(46,10);
	stdp->writeChar(' ');
	stdp->setCursor(42,11);
	stdp->writeChar(' ');
	stdp->setCursor(42,12);
	stdp->writeChar(' ');
	stdp->setCursor(43,12);
	stdp->writeChar(' ');
	stdp->setCursor(44,12);
	stdp->writeChar(' ');
	stdp->setCursor(42,13);
	stdp->writeChar(' ');
	stdp->setCursor(42,14);
	stdp->writeChar(' ');
	stdp->setCursor(43,14);
	stdp->writeChar(' ');
	stdp->setCursor(44,14);
	stdp->writeChar(' ');
	stdp->setCursor(45,14);
	stdp->writeChar(' ');
	stdp->setCursor(46,14);
	stdp->writeChar(' ');

	//S
	stdp->setCursor(49,10);
	stdp->writeChar(' ');
	stdp->setCursor(50,10);
	stdp->writeChar(' ');
	stdp->setCursor(51,10);
	stdp->writeChar(' ');
	stdp->setCursor(52,10);
	stdp->writeChar(' ');
	stdp->setCursor(53,10);
	stdp->writeChar(' ');
	stdp->setCursor(49,11);
	stdp->writeChar(' ');
	stdp->setCursor(49,12);
	stdp->writeChar(' ');
	stdp->setCursor(50,12);
	stdp->writeChar(' ');
	stdp->setCursor(51,12);
	stdp->writeChar(' ');
	stdp->setCursor(52,12);
	stdp->writeChar(' ');
	stdp->setCursor(53,12);
	stdp->writeChar(' ');
	stdp->setCursor(53,13);
	stdp->writeChar(' ');
	stdp->setCursor(53,14);
	stdp->writeChar(' ');
	stdp->setCursor(52,14);
	stdp->writeChar(' ');
	stdp->setCursor(51,14);
	stdp->writeChar(' ');
	stdp->setCursor(50,14);
	stdp->writeChar(' ');
	stdp->setCursor(49,14);
	stdp->writeChar(' ');

	//MINA
	/*stdp->setColor(ANORMAL, CBLACK, CBLACK);
	stdp->setCursor(57,12);
	stdp->writeChar(' ');
	stdp->setCursor(58,11);
	stdp->writeChar(' ');
	stdp->setCursor(58,12);
	stdp->writeChar(' ');
	stdp->setCursor(58,13);
	stdp->writeChar(' ');
	stdp->setCursor(59,10);
	stdp->writeChar(' ');
	stdp->setCursor(59,11);
	stdp->writeChar(' ');
	stdp->setCursor(59,12);
	stdp->writeChar(' ');
	stdp->setCursor(59,13);
	stdp->writeChar(' ');
	stdp->setCursor(59,14);
	stdp->writeChar(' ');
	stdp->setCursor(60,11);
	stdp->writeChar(' ');
	stdp->setCursor(60,12);
	stdp->writeChar(' ');
	stdp->setCursor(60,13);
	stdp->writeChar(' ');
	stdp->setCursor(61,12);
	stdp->writeChar(' ');*/

	//BOMBA2
	stdp->setColor(ANORMAL, CBLACK, CBLACK);
	stdp->setCursor(57,12);
	stdp->writeChar(' ');
	stdp->setCursor(58,11);
	stdp->writeChar(' ');
	stdp->setCursor(58,12);
	stdp->writeChar(' ');
	stdp->setCursor(58,13);
	stdp->writeChar(' ');
	stdp->setCursor(59,10);
	stdp->writeChar(' ');
	stdp->setCursor(59,11);
	stdp->writeChar(' ');
	stdp->setCursor(59,12);
	stdp->writeChar(' ');
	stdp->setCursor(59,13);
	stdp->writeChar(' ');
	stdp->setCursor(59,14);
	stdp->writeChar(' ');
	stdp->setCursor(60,10);
	stdp->writeChar(' ');
	stdp->setCursor(60,11);
	stdp->writeChar(' ');
	stdp->setCursor(60,12);
	stdp->writeChar(' ');
	stdp->setCursor(60,13);
	stdp->writeChar(' ');
	stdp->setCursor(60,14);
	stdp->writeChar(' ');
	stdp->setCursor(61,10);
	stdp->writeChar(' ');
	stdp->setCursor(61,11);
	stdp->writeChar(' ');
	stdp->setCursor(61,12);
	stdp->writeChar(' ');
	stdp->setCursor(61,13);
	stdp->writeChar(' ');
	stdp->setCursor(61,14);
	stdp->writeChar(' ');
	stdp->setCursor(62,11);
	stdp->writeChar(' ');
	stdp->setCursor(62,12);
	stdp->writeChar(' ');
	stdp->setCursor(62,13);
	stdp->writeChar(' ');
	stdp->setCursor(63,12);
	stdp->writeChar(' ');

	//mecha
	stdp->setColor(ANORMAL, CWHITE, CBLUE);
	stdp->setCursor(60,9);
	stdp->writeChar('|');
	stdp->setCursor(61,8);
	stdp->writeChar('|');
	

	if (cntMecha<2)
	{
		stdp->setColor(ANORMAL, CYELLOW, CBLUE);
		stdp->setCursor(61,7);
		stdp->writeChar('*');
	}
	if (cntMecha>3)
	{
		cntMecha = 0;
	}
	else
	{
		cntMecha++;
	}
}
